"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Any, Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk import utils
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import validate_open_enum


class AtsInterviewStatus(str, Enum, metaclass=utils.OpenEnumMeta):
    SCHEDULED = "SCHEDULED"
    AWAITING_FEEDBACK = "AWAITING_FEEDBACK"
    COMPLETE = "COMPLETE"
    CANCELED = "CANCELED"
    NEEDS_SCHEDULING = "NEEDS_SCHEDULING"


class AtsInterviewTypedDict(TypedDict):
    application_id: NotRequired[str]
    candidate_id: NotRequired[str]
    created_at: NotRequired[datetime]
    end_at: NotRequired[datetime]
    external_event_xref: NotRequired[str]
    id: NotRequired[str]
    job_id: NotRequired[str]
    location: NotRequired[str]
    raw: NotRequired[Dict[str, Any]]
    start_at: NotRequired[datetime]
    status: NotRequired[AtsInterviewStatus]
    updated_at: NotRequired[datetime]
    user_ids: NotRequired[List[str]]


class AtsInterview(BaseModel):
    application_id: Optional[str] = None

    candidate_id: Optional[str] = None

    created_at: Optional[datetime] = None

    end_at: Optional[datetime] = None

    external_event_xref: Optional[str] = None

    id: Optional[str] = None

    job_id: Optional[str] = None

    location: Optional[str] = None

    raw: Optional[Dict[str, Any]] = None

    start_at: Optional[datetime] = None

    status: Annotated[
        Optional[AtsInterviewStatus], PlainValidator(validate_open_enum(False))
    ] = None

    updated_at: Optional[datetime] = None

    user_ids: Optional[List[str]] = None
