"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
import pydantic
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk import utils
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import validate_open_enum


class ScimAddressType(str, Enum, metaclass=utils.OpenEnumMeta):
    WORK = "work"
    HOME = "home"
    OTHER = "other"


class ScimAddressTypedDict(TypedDict):
    country: NotRequired[str]
    formatted: NotRequired[str]
    locality: NotRequired[str]
    postal_code: NotRequired[str]
    region: NotRequired[str]
    street_address: NotRequired[str]
    type: NotRequired[ScimAddressType]


class ScimAddress(BaseModel):
    country: Optional[str] = None

    formatted: Optional[str] = None

    locality: Optional[str] = None

    postal_code: Annotated[Optional[str], pydantic.Field(alias="postalCode")] = None

    region: Optional[str] = None

    street_address: Annotated[Optional[str], pydantic.Field(alias="streetAddress")] = (
        None
    )

    type: Annotated[
        Optional[ScimAddressType], PlainValidator(validate_open_enum(False))
    ] = None
